using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using SpringPCSCAPI;
using System.Runtime.InteropServices;

namespace CardTool
{
  public partial class ReaderStatusFrm : Form
  {
    string card_subtype = "";
    string card_uid = "";
   // string card_atq = "";
    string type_card = "";
    RWCardFrm readFrm;
    public ReaderStatusFrm()
    {
      SplashFrm MySplashForm = new SplashFrm();
      MySplashForm.Show();
      
     
      ThStatusDeleg = new ThreadFinishedDelegate(onStatusDone);
      
      // Which PixNN need further investigation to determinate type
      CardSubType();
      GetTypes();

      InitializeComponent();
    }

#region reader
    /* Set the reader chosen in ChooseReaderFrm*/
    public void SetReader(string readerName)
    {
      ReaderNameTb.Text = readerName;
      SPCSC.SetReader(readerName);
    }

    /* Display ChooseReaderFrm to select another reader */
    private void buttonChangeReader_Click(object sender, EventArgs e)
    {
      ChooseReaderFrm configFrm = new ChooseReaderFrm(this, false);
      configFrm.ShowDialog();
    }
#endregion

#region card status
    /* check every 100ms card status for selected reader, 
     * and change interface according to status found */

    System.Threading.Thread StatusThread = null; /* Get reader status */
    public ThreadFinishedDelegate ThStatusDeleg;
    public delegate void ThreadFinishedDelegate();
    public string StatusStr = "";

    public void ThStatusProc()
    {
      string str = SPCSC.CheckStatus();
      StatusStr = str;
      if (str.Contains(":"))
      StatusStr = StatusStr.Remove(str.IndexOf(':'));
      try
      {
          Invoke(ThStatusDeleg);
      }
      catch (Exception e) { }

    }

    private void timerStatus_Tick(object sender, EventArgs e)
    {
      StatusThread = new System.Threading.Thread(new
      System.Threading.ThreadStart(ThStatusProc));
      StatusThread.Start();
    }
    
    public void onStatusDone()
    {
      CardStatusTb.Text = StatusStr;
      if (CardStatusTb.Text == "")
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        Reset();
      }
      if (CardStatusTb.Text.Contains("PRESENT"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Show();
        //buttonRead.Enabled = true;
        GetAtr();
      }
      if (CardStatusTb.Text.Contains("INUSE"))
      {
        pictureBoxAbs.Hide();
        pictureBoxAl.Hide();
        pictureBoxC.Show();
        pictureBoxP.Hide();
        GetAtr();
      }
      if (CardStatusTb.Text.Contains("EMPTY"))
      {
        pictureBoxAbs.Show();
        pictureBoxAl.Hide();
        pictureBoxC.Hide();
        pictureBoxP.Hide();
        Reset();
      }
    }

    public void Reset()
    {
      buttonRead.Enabled = false;
      SubTypeTb.Visible = false;
      SubTypeLabel.Visible = false;
      CardAtrTb.Text = "";
      CardTypeTb.Text = "";
      card_subtype = "";
      card_uid = "";
      //card_atq = "";
      CardUidTb.Text = "";
      type_card = "";
    }
#endregion

#region card ATR / UID
    //byte[] AtrArray;
    String AtrStr;

    public void GetAtr()
    {
      /*AtrArray = SPCSC.CurrentATR();
      String Str = "";
      for (int cpt = 0; cpt < AtrArray.Length; cpt++)
        Str += String.Format("{0:X02}", AtrArray[cpt]);*/
      AtrStr = SPCSC.GetAtrStr();
      CardAtrTb.Text = AtrStr;
      GetCardType();
      bool knowntype = false;

      for (int i = 0; i < type_sections.Length; i++)
      {
       
        if (type_sections[i] == type_card)
          knowntype = true;
      }
      if (type_card == "")
        knowntype = false;
      buttonRead.Enabled = knowntype;
    }

    public string GetUID()
    {
      APDUCmd CmdGetUid = new APDUCmd("FF CA 00 00 00");
      APDURsp RspUid = new APDURsp();
      timerStatus.Enabled = false;
      SPCSC.ConnectCard();
      SPCSC.Transmit(CmdGetUid, ref RspUid);
      CardUidTb.Text = RspUid.DataOutStr;
      SPCSC.Disconnect();
      timerStatus.Enabled = true;
      return (RspUid.DataOutStr.Replace(" ","").Substring(0, 6));
    }

   /* public string GetATQ()
    {
      APDUCmd CmdGetUid = new APDUCmd("FF CA F0 00 00");
      APDURsp RspUid = new APDURsp();
      timerStatus.Enabled = false;
      SPCSC.ConnectCard();
      SPCSC.Transmit(CmdGetUid, ref RspUid);
      
      SPCSC.Disconnect();
      timerStatus.Enabled = true;
      return (RspUid.DataOutStr.Replace(" ", "").Substring(0, 4));
    }*/
#endregion

#region card type
    int pixnnIndex = 26;
    const int max_sections = 255;
    string[] subtype_sections;
    string[] type_sections;
   

    /* DllImport for 2 functions, to get data from ini files */
    [DllImport("kernel32")]
    private static extern int GetPrivateProfileString(string section,
        string key, string def, StringBuilder retVal, int size, string filePath);

    [DllImport("kernel32")]
    private static extern int GetPrivateProfileSectionNames
      (byte[] retVal, int size, string filePath);

    public void GetCardType()
    {
      if(card_uid=="")
       card_uid = GetUID();

      if (AtrStr.Length > 25)
      {
        CardTypeTb.Text = IniReadValue("PIXNN", AtrStr.Substring(pixnnIndex, 4));
        bool subtype = false;
        for (int i = 0; i < subtype_sections.Length; i++)
        {
          if (subtype_sections[i] == AtrStr.Substring(pixnnIndex, 4))
            subtype = true;
        }

        if (type_card == "")
        {
       
          
          if ((subtype) && (card_subtype == ""))
          {
           /* if (AtrStr.Substring(pixnnIndex, 4) == "FFA0")
            {
              if (card_atq == "")
                card_atq = GetATQ();
              GetSubtype(AtrStr.Substring(pixnnIndex, 4), card_atq);
              type_card = card_atq.Replace(" ", "");
            }*/
           // else
           // {
              GetSubtype(AtrStr.Substring(pixnnIndex, 4), card_uid);
              type_card = card_uid.Replace(" ", "");
            //}
          }
          else
            type_card = AtrStr.Substring(pixnnIndex, 4);
        }

        
      }

    }

    public string IniReadValue(string Section, string Key)
    /* get initialization data from ini file */
    {
      StringBuilder temp = new StringBuilder(500);
      String CurrentDir = Application.StartupPath;
      int i = GetPrivateProfileString(Section, Key, "", temp, 500, CurrentDir + "/pix_values.ini");
      return temp.ToString();
    }

    public string IniSubTypeValue(string Section, string Key)
    /* get initialization data from ini file */
    {
      StringBuilder temp = new StringBuilder(500);
      String CurrentDir = Application.StartupPath;
      int i = GetPrivateProfileString(Section, Key, "", temp, 500, CurrentDir + "/sub_types.ini");
      return temp.ToString();
    }

    public string CardSubType()
    /* get initialization data from ini file */
    {
      byte[] buffer = new byte[max_sections];
      String CurrentDir = Application.StartupPath;
      int size = GetPrivateProfileSectionNames(buffer, max_sections, CurrentDir + "/sub_types.ini");
      
      string result ="";
      //Convert the buffer into a string.  Decrease the length
      //by 1 so that we remove the second null off the end.

      //Parse the buffer into an array of strings by searching for nulls.
      subtype_sections = Encoding.Default.GetString(buffer, 0, size).TrimEnd('\0').Split('\0');


      for (int i = 0; i < subtype_sections.Length; i++)
        result += subtype_sections[i] + " ";
      
      return result;

    }

    public string GetTypes()
    /* get initialization data from ini file */
    {
      byte[] buffer = new byte[max_sections];
      String CurrentDir = Application.StartupPath;
      int size = GetPrivateProfileSectionNames(buffer, max_sections, CurrentDir + "/type_card.ini");

      string result = "";
      //Convert the buffer into a string.  Decrease the length
      //by 1 so that we remove the second null off the end.

      //Parse the buffer into an array of strings by searching for nulls.
      type_sections = Encoding.Default.GetString(buffer, 0, size).TrimEnd('\0').Split('\0');


      for (int i = 0; i < type_sections.Length; i++)
        result += type_sections[i] + " ";

      return result;

    }

    public void GetSubtype(string section,string uid)
    {
      /*APDUCmd CmdGetSubType = new APDUCmd("FF CA 00 00 03");
      APDURsp RspSubType = new APDURsp();
      timerStatus.Enabled = false;
      SPCSC.ConnectCard();
      SPCSC.Transmit(CmdGetSubType, ref RspSubType);*/
     // SPCSC.GetCardType();
     // SPCSC.Disconnect(2);
     // MessageBox.Show("."+section + ". - ." + uid+".");
      SubTypeTb.Text = IniSubTypeValue(section, uid.Replace(" ",""));
     // SubTypeTb.Text = IniSubTypeValue(section, SPCSC.GetCardSubType().Replace(" ", "")); //SPCSC.GetCardSubType();
      //SPCSC.Disconnect();
      card_subtype = SubTypeTb.Text;
      SubTypeTb.Visible = true;
      SubTypeLabel.Visible = true;
      //timerStatus.Enabled = true;
    }
   
#endregion

    private void buttonRead_Click(object sender, EventArgs e)
    {
      timerStatus.Enabled = false;
      if (type_card == "0003") // Mifare Ultralight
      {
        RWMifUlFrm readULFrm = new RWMifUlFrm(this);
        readULFrm.Show();
      }
      else
      {
        readFrm = new RWCardFrm(type_card, this);
        readFrm.Show();
      }
      
     
    }

    public void Restart_Timer()
    {
      Reset();
      timerStatus.Enabled = true;
    }

    private void ReaderStatusFrm_Shown(object sender, EventArgs e)
    {
      /* Showing configuration form - User has to select reader */
      ChooseReaderFrm cf = new ChooseReaderFrm(this, true);
      cf.ReadRegister();

      if ((cf.ReaderName == "") || (!cf.connect))
        cf.ShowDialog();
      else
        SetReader(cf.ReaderName);

    }

    private void toolStripMenuItem1_Click(object sender, EventArgs e)
    {
      AboutBoxFrm a = new AboutBoxFrm();
      a.Show();
    }


  }
}