using System;
using System.Collections.Generic;
using System.Text;

namespace SpringPCSCAPI
{
  public class APDURsp
  {
    public const int MAX_RECV_LEN = 260;
    private byte[] _APDUArray;
    private string _APDUStr;


    // receiving variables
    private byte[] _DataOut;
    private byte _SW1;
    private byte _SW2;
    private string _DataOutStr;
    //   private string _recAPDUStr; 



    // construct a receiving APDU
    public APDURsp(byte[] retBuf)
    {
      if (retBuf.Length == 0)
        return;
      
      _APDUStr = createStrFromByteArray(retBuf);
      _APDUArray = retBuf;
      if (retBuf.Length <= 2)
      {
        _SW1 = retBuf[0];
        if (retBuf.Length == 2)
          _SW2 = retBuf[1];
      }
      else
      {
        _DataOut = new byte[retBuf.Length - 2];
        for (int cpt = 0; cpt < (retBuf.Length - 2); cpt++)
          _DataOut[cpt] = retBuf[cpt];
        _DataOutStr = createStrFromByteArray(_DataOut);
        _SW1 = retBuf[retBuf.Length - 2];
        _SW2 = retBuf[retBuf.Length - 1];
      }

    }

    // accept 0 arg
    public APDURsp()
    {
    }




    private string createStrFromByteArray(byte[] byteArray) 
    {
      string Str = "";
      if (byteArray.Length <= 0)
        return Str;
      for (int cpt = 0; cpt < byteArray.Length - 1; cpt++)
        Str += String.Format("{0:X02}", byteArray[cpt]) + " ";
      Str += String.Format("{0:X02}", byteArray[byteArray.Length - 1]);
      return Str;
    }

    private byte[] createByteArrayFromStr(string Str)
    {
      if (!Str.Contains(" "))
      {
        string nStr = "";
        for (int cpt = 0; cpt < Str.Length; cpt = cpt + 2)
        {
          nStr = nStr + Str.Substring(cpt, 2) + " ";
        }
        Str = nStr;
      }

      // command stored into byte array
      char[] delimiterByte = new char[1];
      delimiterByte[0] = ' ';
      string properStr = Str;
      // removing last " "
      if (Str.EndsWith(" "))
      {
        properStr = Str.Substring(0, Str.Length - 1);
      }

      string[] Strbuff = properStr.Split(delimiterByte);
      byte[] StrBuffer = new byte[Strbuff.Length];
      for (int i = 0; i < Strbuff.Length; i++)
      {
        // converting byte string to byte  
        StrBuffer[i] = System.Convert.ToByte(int.Parse(Strbuff[i],
          System.Globalization.NumberStyles.HexNumber));
      }
      return StrBuffer;
    }



    public override string ToString() 
    {
      return _APDUStr;
    }

    public byte[] ToByteArray()
    {
      return _APDUArray;
    }


    public byte[] DataOut
    {
      get { return _DataOut; }
      //set { _DataOut = value;}
    }

    public byte SW1
    {
      get { return _SW1; }
      //set { _SW1 = value;}
    }

    public byte SW2
    {
      get { return _SW2; }
      // set { _SW2 = value;}
    }

    public string DataOutStr
    {
      get { return _DataOutStr; }
      //set { _DataOutStr = value;}
    }


    public byte[] APDUArray
    {
      get { return _APDUArray; }
      //set { _APDUArray = value;}
    }

    public string APDUStr
    {
      get { return _APDUStr; }
      //set { _APDUStr = value;}
    }

  }
}
